<?php

// Id used to identify this page within functions.
$PageID = "SEARCH";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "layout.inc";
require_once "search.inc";
require_once "language.inc";
require_once "MARC.inc";

$onload = "document.quick_search.query.select();";

layout_header(array('onload' => $onload));

layout_page_title();

layout_wizard_start();

?>
	<form name='quick_search' action='search.php' method='get'>
		<input type="hidden" name="exact_query" value="<?php echo (isset($_REQUEST['exact_query']) && $_REQUEST['exact_query'] != '') ? '1' : '';?>">
		<input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
		<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>

		<table cellpadding="6" cellspacing="0" border="0">

		<tr>
			<td align="right">
				<?php echo $langText['SEARCH_BY'] ?>:
			</td>
			<td align="left">
				<select name='criteria'>
					<option value="book_id"><?php echo $langText['BOOK_ID']?></option>

				<?php

					foreach ($MARC_searchable as $searchable)
					{
						if (isset($_REQUEST['criteria']) && $_REQUEST['criteria'] == $searchable) {
							$selected = ' selected';
						}
						else {
							$selected = '';
						}

						print '<option value="' . $searchable . '"' . $selected . '>' . $langText[strtoupper($MARC_config[$searchable])] . '</option>';
					}

				?>

				</select>
			</td>
		</tr>

		<tr>
			<td></td>
			<td align="left">
				<input type='text' size='30' name='query' value="<?php
																	echo (isset($_REQUEST['query']))
																	? $_REQUEST['query']
																	: '';
																?>" onchange="document.forms.quick_search.exact_query.value='';">
			</td>
		</tr>
		
		<tr>
			<td>&nbsp;</td>
			<td align="left">
				<input type='submit' name='submit' value='<?php echo $langText['BUTTON_SEARCH'] ?> >>' class='button'>
			</td>
		</tr>

		<tr>
			<td colspan="2">&nbsp;</td>
		</tr>

		<tr>
			<td align="right">
				<?php echo $langText['SEARCH_LOCATION'] ?>:
			</td>
			<td>
				<select name='location'>

				<?php

				$res = mysql_query("SELECT location_id, location_name FROM locations");
				while ($row = mysql_fetch_array($res))
				{

					print "<option value='".$row['location_id']."'";
					if(!isset($_REQUEST['location']) && $row['location_id'] == USER_LOCATION)
					{
						print " selected";
					}
					elseif(isset($_REQUEST['location']) && $row['location_name'] == $_REQUEST['location'])
					{
						print " selected";
					}
					print ">".$row['location_name']."</option>";
				}

				?>

					<option value="all" <?php echo (isset($_REQUEST['location']) && $_REQUEST['location'] == "all") ? "selected" : "";?>><?php echo $langText['LOCATION_ALL']?></option>
				</select>
			</td>
		</tr>

		<tr>
			<td>&nbsp;</td>
			<td align="left" valign="top">
				<input type="checkbox" name="in_shelf"<?php if(isset($_REQUEST['in_shelf'])) echo " checked"; ?>> <?php echo $langText['STATUS_IN_SHELF']?><br />
				<input type="checkbox" name="not_reserved"<?php if(isset($_REQUEST['not_reserved'])) echo " checked"; ?>> <?php echo $langText['STATUS_NOT_RESERVED']?><br />
			</td>
		</tr>

	</table>

	</form>

<?php

layout_wizard_stop();

if (isset($_REQUEST['query']))
{
	$hits_per_page = 10;
	$position = 1;
	if (empty ($_REQUEST['order_by']))
        {
        	$_REQUEST['order_by'] = $_REQUEST['criteria'];
         	$_REQUEST['order_dir'] = 'ai';
        }

	if (isset($_REQUEST['position']))
		$position = $_REQUEST['position'];
		
	if(isset($_REQUEST['location'])) {
		if($_REQUEST['location'] == "all") {
			$extra_attributes = "";
		} else {
			$extra_attributes = "@and @attr 1=1038 \"".$_REQUEST['location']."\"";
		}
	} else {
		$extra_attributes = "";
	}

	$_REQUEST['element'] = 'F'; //In quick-search it is not possible to change the complexity of the search.
	
	if($_REQUEST['criteria'] != 'book_id')
	{
		$formatted_query = boolify_query($_REQUEST['query']);
	}
	elseif($_REQUEST['criteria'] == 'book_id')
	{
		if(is_book($_REQUEST['query']) && is_last_char($_REQUEST['query'], $config['book_id_suffix']))
		{
			if(is_last_char($_REQUEST['query'], $config['book_id_suffix']))
			$raw_id = chop_last($_REQUEST['query']);
			
			$res = mysql_query("SELECT book_control_number FROM books WHERE book_id=".$raw_id);
			if(mysql_num_rows($res))
			{
				$row = mysql_fetch_array($res);
				$formatted_query = format_control_number($row['book_control_number']);
				$_REQUEST['criteria'] = '001';
				$book_id_status = 'ok';
			}
			else
			{
				$book_id_status = 'no_such_book';
			}
		}
		else
		{
			$book_id_status = 'invalid_book_id';
		}
	}

	if(isset($formatted_query) && $formatted_query == "error bool") {
		$error = $langText['ERROR_BOOL'];
		$hits = 0;
	}
	elseif (isset($book_id_status) && $book_id_status == 'invalid_book_id') {
		$error = $langText['ERROR_BOOK_ID'];
		$hits = 0;
	}
	elseif (isset($book_id_status) && $book_id_status == 'no_such_book') {
		$hits = 0;
	}
	else {
		if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == '')) {
			list($YAZ_items, $hits) = search($_REQUEST['criteria'], $formatted_query, 1, 'hits'); //Call quick-search from search.inc
		} else {
			list($YAZ_items, $hits) = search($_REQUEST['criteria'], $formatted_query, $position, $hits_per_page); //Call quick-search from search.inc
		}
		//list($YAZ_items, $hits, $MARC_raw) = search($criteria, $query, $position, $hits_per_page, $url, "raw");
		$how_many = $hits_per_page;

		// Verify that not more records are fetched than are to be displayed
		// on the current page.
		if(($hits - (($position-1) + $hits_per_page)) < 0) {
			$how_many = $hits-($position-1);
		}
	}

	$rowCount = $hits; //Retrieve the number of records.

	if ($rowCount)
	{
		//$maxNumber = 100;
		//$overflowText = ($rowCount > $maxNumber) ? $langText['TOOMANYBOOKSFOUND'] : "";

		if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == '')) {
			$i=0;
			$authors = array();
			$parsed_entries=0;
			//print_r($YAZ_items);
			//print "HITS: ".$hits;
			//print_r($YAZ_items[0]);
			while($hits > $i/* && count($authors) <= $how_many*/)
			{
				parseMARC($YAZ_items[$i]);
				
				if(array_key_exists('100', $MARC) && array_key_exists('a', $MARC['100'])) {
					$author = $MARC['100']['a'];
					$author = preg_replace('/\W$/', '', $author);
					if(array_key_exists($author, $authors)) {
						$authors[$author] += 1;
					} else {
						$authors[$author] = 1;
					}
				}
				$i++;
			}
			$i=0;
			while($i < ($position - 1))
			{
				array_shift($YAZ_items);
				$i++;
			}
			//print "BEFORE (pos $position):".$YAZ_items[$position-1];
			//print "AFTER (pos 0):".$YAZ_items[0];
		}
		
		if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == '')) {
			$foundText = ($rowCount == 1) ? $langText['AUTHOR_FOUND'] : $langText['AUTHORS_FOUND'];
			layout_page_info(count($authors) . ' ' . $foundText . ':', 'ok');
		} else {
			$foundText = ($rowCount == 1) ? $langText['BOOKFOUND'] : $langText['BOOKSFOUND'];
			$foundText .= " (".$langText['OVER_ALL'].")";
			layout_page_info($rowCount . ' ' . $foundText . ':', 'ok');
		}

//		if ($overflowText)
//			print "<blockquote><font class='error'>" . $overflowText . " " . $maxNumber . "</font></blockquote>";

		$headers = array("&nbsp;", '');

		if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == '')) {
			foreach ($MARC_author_display as $key => $value)
			{
				array_push($headers, $langText[strtoupper($MARC_config[$key])]);
			}
			array_push($headers, $langText['BOOK_ENTRIES']);
		} else {
			foreach ($MARC_display_in_list as $value)
			{
				array_push($headers, $langText[strtoupper($MARC_config[$value])]);
			}
			array_push($headers, $langText['BOOK_GRADE_AVERAGE']);
			array_push($headers, $langText['BOOK_COMMENTS']);
		}

		//$headers = array_merge ($headers, layout_table_sort ("search.php?id=" . $_REQUEST['id'] . "&auth=" . $_REQUEST['auth'] . "&criteria=" . $_REQUEST['criteria'] . "&query=" . $_REQUEST['query'], $fields));
		
		$i = 0;
		$table_rows = 0;
		$printed = array();
		$table_header = false;
		$narrowed_count = 0;
		$display_narrowed_count = false;
		while($rowCount > $i && $table_rows < $how_many)
		{
			$content = array();
			$row = array();
			$go = true;

			#print_r($MARC_author_display);
			
			parseMARC($YAZ_items[$i]);
			
			if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == '')) {
				if(array_key_exists('100', $MARC) && array_key_exists('a', $MARC['100'])) {
					$author = $MARC['100']['a'];
					$author = preg_replace('/\W$/', '', $author);
					if(array_key_exists($author, $printed)) {
						$go = false;
					} else {
						$printed[$author] = 'printed';
					}
					$parsed_entries += $authors[$author];
				}
				$row = createMARCRow($MARC_author_display);
			} else {
				$display_narrowed_count = true;
				
				if($_REQUEST['location'] == 'all') {
					$location_sql = '';
				} else {
					$location_sql = " AND book_location='".$_REQUEST['location']."'";
				}

				if (isset($_REQUEST['in_shelf']) && isset($_REQUEST['not_reserved']))
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							AND book_borrowed=0 AND book_reserved=0".$location_sql;
				}
				elseif(isset($_REQUEST['in_shelf']))
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							AND book_borrowed=0".$location_sql;
				}
				elseif (isset($_REQUEST['not_reserved']))
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							AND book_reserved=0".$location_sql;
				}
				else
				{
					$sql = 	"SELECT book_id
							FROM books
							WHERE book_control_number=".book_control_number()."
							".$location_sql;
				}

				$res = mysql_query($sql);
				if(mysql_num_rows($res)) {
					$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
					$narrowed_count++;
				} else {
					$go = false;
				}
			}		
				
			if($go)
			{
				if(!$table_header) {
					layout_table_header($headers);
					$table_header = true;
				}	
					
				// For debugging purposes!
				/*print "MARC: ";
				print_r($MARC);
				print "<br><br><br>";

				print "ROW: ";
				print_r($row);
				print "<br><br><br>";*/

				if(array_key_exists('book_isbn', $row) && $row['book_isbn'] != "")
					$row['book_isbn'] = format_isbn($row['book_isbn']);


				$info =	"<a href='book_info.php?id=" . $_REQUEST['id'] .
						"&auth=" . $_REQUEST['auth'] .
						"&book_control_number=" . book_control_number() .
						"&search_criteria=" . $_REQUEST['criteria'] .
						"&search_query=" . $_REQUEST['query'] .
						"&search_position=" . $position .
						"&search_location=" . $_REQUEST['location'] .
						"&exact_query=".$_REQUEST['exact_query'];

				if (isset($_REQUEST['in_shelf'])) $info .= "&in_shelf";
				if (isset($_REQUEST['not_reserved'])) $info .= "&not_reserved";

				$info .= "'>" . layout_insertImg('icon_info.png') . "</a>";

				if(check_priv('EDIT'))
				{
					$edit_suggest = layout_blankImg(5) .
									"<a href='book_edit.php?id=" . $_REQUEST['id'] .
									"&auth=" . $_REQUEST['auth'] .
									"&book_control_number=" . book_control_number() .
									"&search_criteria=" . $_REQUEST['criteria'] .
									"&search_query=" . $_REQUEST['query'] .
									"&search_position=" . $position .
									"&search_location=" . $_REQUEST['location'] .
									"&exact_query=" . $_REQUEST['exact_query'];

					if (isset($_REQUEST['in_shelf'])) $edit_suggest .= "&in_shelf";
					if (isset($_REQUEST['not_reserved'])) $edit_suggest .= "&not_reserved";

					$edit_suggest .= "'>" . layout_insertImg('icon_edit.png') . "</a>";

					$form = '';
				}
				else {
					$edit_suggest = '';
					$form = '';
				}

				if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == ''))
				{
					$exact = 	"<a href='search.php?id=" . $_REQUEST['id'] .
								"&auth=" . $_REQUEST['auth'] .
								"&criteria=" . $_REQUEST['criteria'] .
								"&query=" . $author .
								"&exact_query=1" .
								"&location=" . $_REQUEST['location'];

					if (isset($_REQUEST['in_shelf'])) $exact .= "&in_shelf";
					if (isset($_REQUEST['not_reserved'])) $exact .= "&not_reserved";

					$exact .=	"'>" . layout_insertImg('icon_info.png') . "</a>";

					array_push($content, $exact, "&nbsp;");
				}
				else {
					array_push($content, $info . $edit_suggest, $form);
				}

				while(list($key, $value) = each($row))
				{
					array_push($content, $row[$key]);
				}
				
				if ($display_narrowed_count) {
					$grades = mysql_fetch_array(mysql_query(	"SELECT TRUNCATE(AVG(grade_number),1) AS average FROM grades WHERE grade_book_control_no=".book_control_number()." GROUP BY grade_book_control_no"));
					$comments = mysql_query("SELECT comment_id FROM comments WHERE comment_book_control_no=".book_control_number());
				}
				
				if($display_narrowed_count) {
					array_push($content, $grades['average']);
					array_push($content, mysql_num_rows($comments));
				}
								
				if($_REQUEST['criteria'] == '100' && (!isset($_REQUEST['exact_query']) || $_REQUEST['exact_query'] == '')) {
					array_push($content, $authors[$author]);
				} 
				
				layout_table_row($content);
				$table_rows++;
			}
			$i++;

		}
		if($table_header) {
			$page_index = '';
			if($display_narrowed_count) {
				$filtered = guess_filtered_hits($hits, $hits_per_page, $i, $table_rows);
				$page_index = "<span class='page-index'><b>".$filtered."</b> ";
				$page_index .= ($narrowed_count == 1) ? $langText['FILTERED_HIT'] : $langText['FILTERED_HITS'];
			}
			
			$exact_query = (isset($_REQUEST['exact_query'])) ? $_REQUEST['exact_query'] : '';
			
			if(isset($authors)) {
				$dist_hits = count($authors);
				$dist_position = $position;
			} else {
				$dist_hits = $hits;
				$dist_position = $position;
			}

			$index_url =	"search.php?id=" . $_REQUEST['id'] .
							"&auth=" . $_REQUEST['auth'] .
							"&criteria=" . $_REQUEST['criteria'] .
							"&query=" . $_REQUEST['query'] .
							"&location=" . $_REQUEST['location'] .
							"&exact_query=" . $exact_query;

			if (isset($_REQUEST['in_shelf'])) $index_url .= "&in_shelf";
			if (isset($_REQUEST['not_reserved'])) $index_url .= "&not_reserved";

			$index = create_page_index($dist_hits, $dist_position, $hits_per_page, $index_url);

			if($index && $display_narrowed_count) {
				$page_index .= " | </span>".$index;
			} elseif($index && !$display_narrowed_count) {
				$page_index .= "</span>".$index;
			} else {
				$page_index .= "</span>";
			}
				
        	layout_table_footer($page_index);
		} elseif($display_narrowed_count) {
			$text = $narrowed_count." ";
			$text .= ($narrowed_count == 1) ? $langText['FILTERED_HIT'] : $langText['FILTERED_HITS'];
			layout_page_info($text);
		}
	}

	else
	{
        if(isset($error))
			layout_page_info($error, 'error');
		else
			layout_page_info($langText['NOBOOKSFOUND'], 'error');
	}

}

layout_footer();

?>
